#include <string.h>
#include <stdio.h>
#include <windows.h>
#include "BSL_Definitions.h"

unsigned char UART_initialize_BSL_5438(unsigned char* comPort, long rate, unsigned int mode, unsigned char family);
unsigned char UART_initialize_BSL(unsigned char* comPort, long rate, unsigned int mode, unsigned char family);
unsigned char readByte();
void writeByte(unsigned char * byte, unsigned int size);
void changeCommBaudRate(unsigned int rate);
void invokeBSL(unsigned int mode);
void UART_setVerbose(unsigned int val);
unsigned int UART_GetVerbose();
void clearBuffers(void);
void ReadGargbageUntilTimeout(void);

/* Size of internal WINDOWS-Comm-Buffer: */
#define QUEUE_SIZE            512
#define MAX_UART_FRAME_SIZE   QUEUE_SIZE
#define TIMEOUT_ERROR         0xEE
#define BAUD_SYNC             0xFF
#define BSL_ACK               0x00
#define BSL_WRONG_HEADER      0x51
#define BSL_NACK              0xFF
#define WRONG_FAMILY          1

#define TIMEOUT_MS 300
#define UART 1
#define USB  2
#define I2C  3
#define SPI  4

/* device families */
#define FAMILY_5438   1
#define FAMILY_ROM    2
#define FAMILY_FLASH  3
#define FAMILY_FRAM   4
#define FAMILY_MSP432 5